// Code generated by counterfeiter. DO NOT EDIT.
package letterboxfakes

import (
	"sync"

	"gitlab.com/hackandsla.sh/letterbox/internal/letterbox"
)

type FakeDatastore struct {
	AddDomainStub        func(*letterbox.Domain) error
	addDomainMutex       sync.RWMutex
	addDomainArgsForCall []struct {
		arg1 *letterbox.Domain
	}
	addDomainReturns struct {
		result1 error
	}
	addDomainReturnsOnCall map[int]struct {
		result1 error
	}
	AddMessageStub        func(*letterbox.Mailbox, *letterbox.EncryptedMessage) error
	addMessageMutex       sync.RWMutex
	addMessageArgsForCall []struct {
		arg1 *letterbox.Mailbox
		arg2 *letterbox.EncryptedMessage
	}
	addMessageReturns struct {
		result1 error
	}
	addMessageReturnsOnCall map[int]struct {
		result1 error
	}
	AddUserStub        func(*letterbox.User) error
	addUserMutex       sync.RWMutex
	addUserArgsForCall []struct {
		arg1 *letterbox.User
	}
	addUserReturns struct {
		result1 error
	}
	addUserReturnsOnCall map[int]struct {
		result1 error
	}
	AddUserKeyStub        func(*letterbox.User, *letterbox.UserKey) error
	addUserKeyMutex       sync.RWMutex
	addUserKeyArgsForCall []struct {
		arg1 *letterbox.User
		arg2 *letterbox.UserKey
	}
	addUserKeyReturns struct {
		result1 error
	}
	addUserKeyReturnsOnCall map[int]struct {
		result1 error
	}
	CreateStatStub        func(*letterbox.DomainStat) error
	createStatMutex       sync.RWMutex
	createStatArgsForCall []struct {
		arg1 *letterbox.DomainStat
	}
	createStatReturns struct {
		result1 error
	}
	createStatReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteDomainStub        func(*letterbox.Domain) error
	deleteDomainMutex       sync.RWMutex
	deleteDomainArgsForCall []struct {
		arg1 *letterbox.Domain
	}
	deleteDomainReturns struct {
		result1 error
	}
	deleteDomainReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteMailboxStub        func(*letterbox.Mailbox) error
	deleteMailboxMutex       sync.RWMutex
	deleteMailboxArgsForCall []struct {
		arg1 *letterbox.Mailbox
	}
	deleteMailboxReturns struct {
		result1 error
	}
	deleteMailboxReturnsOnCall map[int]struct {
		result1 error
	}
	DeleteMessageStub        func(*letterbox.EncryptedMessage) error
	deleteMessageMutex       sync.RWMutex
	deleteMessageArgsForCall []struct {
		arg1 *letterbox.EncryptedMessage
	}
	deleteMessageReturns struct {
		result1 error
	}
	deleteMessageReturnsOnCall map[int]struct {
		result1 error
	}
	GetAllDomainsStub        func() ([]letterbox.Domain, error)
	getAllDomainsMutex       sync.RWMutex
	getAllDomainsArgsForCall []struct {
	}
	getAllDomainsReturns struct {
		result1 []letterbox.Domain
		result2 error
	}
	getAllDomainsReturnsOnCall map[int]struct {
		result1 []letterbox.Domain
		result2 error
	}
	GetAllMailboxesStub        func() ([]letterbox.Mailbox, error)
	getAllMailboxesMutex       sync.RWMutex
	getAllMailboxesArgsForCall []struct {
	}
	getAllMailboxesReturns struct {
		result1 []letterbox.Mailbox
		result2 error
	}
	getAllMailboxesReturnsOnCall map[int]struct {
		result1 []letterbox.Mailbox
		result2 error
	}
	GetAllUsersStub        func() ([]letterbox.User, error)
	getAllUsersMutex       sync.RWMutex
	getAllUsersArgsForCall []struct {
	}
	getAllUsersReturns struct {
		result1 []letterbox.User
		result2 error
	}
	getAllUsersReturnsOnCall map[int]struct {
		result1 []letterbox.User
		result2 error
	}
	GetDomainStub        func(string) (*letterbox.Domain, error)
	getDomainMutex       sync.RWMutex
	getDomainArgsForCall []struct {
		arg1 string
	}
	getDomainReturns struct {
		result1 *letterbox.Domain
		result2 error
	}
	getDomainReturnsOnCall map[int]struct {
		result1 *letterbox.Domain
		result2 error
	}
	GetExpiredMailboxesStub        func() ([]letterbox.Mailbox, error)
	getExpiredMailboxesMutex       sync.RWMutex
	getExpiredMailboxesArgsForCall []struct {
	}
	getExpiredMailboxesReturns struct {
		result1 []letterbox.Mailbox
		result2 error
	}
	getExpiredMailboxesReturnsOnCall map[int]struct {
		result1 []letterbox.Mailbox
		result2 error
	}
	GetMailboxByDomainStub        func(*letterbox.Domain, string) (*letterbox.Mailbox, error)
	getMailboxByDomainMutex       sync.RWMutex
	getMailboxByDomainArgsForCall []struct {
		arg1 *letterbox.Domain
		arg2 string
	}
	getMailboxByDomainReturns struct {
		result1 *letterbox.Mailbox
		result2 error
	}
	getMailboxByDomainReturnsOnCall map[int]struct {
		result1 *letterbox.Mailbox
		result2 error
	}
	GetMailboxByExternalIDStub        func(string) (*letterbox.Mailbox, error)
	getMailboxByExternalIDMutex       sync.RWMutex
	getMailboxByExternalIDArgsForCall []struct {
		arg1 string
	}
	getMailboxByExternalIDReturns struct {
		result1 *letterbox.Mailbox
		result2 error
	}
	getMailboxByExternalIDReturnsOnCall map[int]struct {
		result1 *letterbox.Mailbox
		result2 error
	}
	GetMailboxesByDomainStub        func(*letterbox.Domain) ([]letterbox.Mailbox, error)
	getMailboxesByDomainMutex       sync.RWMutex
	getMailboxesByDomainArgsForCall []struct {
		arg1 *letterbox.Domain
	}
	getMailboxesByDomainReturns struct {
		result1 []letterbox.Mailbox
		result2 error
	}
	getMailboxesByDomainReturnsOnCall map[int]struct {
		result1 []letterbox.Mailbox
		result2 error
	}
	GetMessagesStub        func(*letterbox.Mailbox) ([]letterbox.EncryptedMessage, error)
	getMessagesMutex       sync.RWMutex
	getMessagesArgsForCall []struct {
		arg1 *letterbox.Mailbox
	}
	getMessagesReturns struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}
	getMessagesReturnsOnCall map[int]struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}
	GetMessagesForUserStub        func(*letterbox.User) ([]letterbox.EncryptedMessage, error)
	getMessagesForUserMutex       sync.RWMutex
	getMessagesForUserArgsForCall []struct {
		arg1 *letterbox.User
	}
	getMessagesForUserReturns struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}
	getMessagesForUserReturnsOnCall map[int]struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}
	GetStatStub        func(uint, string) (*letterbox.DomainStat, error)
	getStatMutex       sync.RWMutex
	getStatArgsForCall []struct {
		arg1 uint
		arg2 string
	}
	getStatReturns struct {
		result1 *letterbox.DomainStat
		result2 error
	}
	getStatReturnsOnCall map[int]struct {
		result1 *letterbox.DomainStat
		result2 error
	}
	GetUserStub        func(string) (*letterbox.User, error)
	getUserMutex       sync.RWMutex
	getUserArgsForCall []struct {
		arg1 string
	}
	getUserReturns struct {
		result1 *letterbox.User
		result2 error
	}
	getUserReturnsOnCall map[int]struct {
		result1 *letterbox.User
		result2 error
	}
	GetUserByIDStub        func(uint) (*letterbox.User, error)
	getUserByIDMutex       sync.RWMutex
	getUserByIDArgsForCall []struct {
		arg1 uint
	}
	getUserByIDReturns struct {
		result1 *letterbox.User
		result2 error
	}
	getUserByIDReturnsOnCall map[int]struct {
		result1 *letterbox.User
		result2 error
	}
	GetUserKeyStub        func(*letterbox.User) (*letterbox.UserKey, error)
	getUserKeyMutex       sync.RWMutex
	getUserKeyArgsForCall []struct {
		arg1 *letterbox.User
	}
	getUserKeyReturns struct {
		result1 *letterbox.UserKey
		result2 error
	}
	getUserKeyReturnsOnCall map[int]struct {
		result1 *letterbox.UserKey
		result2 error
	}
	UpdateMailboxStub        func(*letterbox.Mailbox) error
	updateMailboxMutex       sync.RWMutex
	updateMailboxArgsForCall []struct {
		arg1 *letterbox.Mailbox
	}
	updateMailboxReturns struct {
		result1 error
	}
	updateMailboxReturnsOnCall map[int]struct {
		result1 error
	}
	UpdateMessageStub        func(*letterbox.EncryptedMessage) error
	updateMessageMutex       sync.RWMutex
	updateMessageArgsForCall []struct {
		arg1 *letterbox.EncryptedMessage
	}
	updateMessageReturns struct {
		result1 error
	}
	updateMessageReturnsOnCall map[int]struct {
		result1 error
	}
	UpdateStatStub        func(*letterbox.DomainStat) error
	updateStatMutex       sync.RWMutex
	updateStatArgsForCall []struct {
		arg1 *letterbox.DomainStat
	}
	updateStatReturns struct {
		result1 error
	}
	updateStatReturnsOnCall map[int]struct {
		result1 error
	}
	UpdateUserStub        func(*letterbox.User) error
	updateUserMutex       sync.RWMutex
	updateUserArgsForCall []struct {
		arg1 *letterbox.User
	}
	updateUserReturns struct {
		result1 error
	}
	updateUserReturnsOnCall map[int]struct {
		result1 error
	}
	UpdateUserKeyStub        func(*letterbox.UserKey) error
	updateUserKeyMutex       sync.RWMutex
	updateUserKeyArgsForCall []struct {
		arg1 *letterbox.UserKey
	}
	updateUserKeyReturns struct {
		result1 error
	}
	updateUserKeyReturnsOnCall map[int]struct {
		result1 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeDatastore) AddDomain(arg1 *letterbox.Domain) error {
	fake.addDomainMutex.Lock()
	ret, specificReturn := fake.addDomainReturnsOnCall[len(fake.addDomainArgsForCall)]
	fake.addDomainArgsForCall = append(fake.addDomainArgsForCall, struct {
		arg1 *letterbox.Domain
	}{arg1})
	stub := fake.AddDomainStub
	fakeReturns := fake.addDomainReturns
	fake.recordInvocation("AddDomain", []interface{}{arg1})
	fake.addDomainMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) AddDomainCallCount() int {
	fake.addDomainMutex.RLock()
	defer fake.addDomainMutex.RUnlock()
	return len(fake.addDomainArgsForCall)
}

func (fake *FakeDatastore) AddDomainCalls(stub func(*letterbox.Domain) error) {
	fake.addDomainMutex.Lock()
	defer fake.addDomainMutex.Unlock()
	fake.AddDomainStub = stub
}

func (fake *FakeDatastore) AddDomainArgsForCall(i int) *letterbox.Domain {
	fake.addDomainMutex.RLock()
	defer fake.addDomainMutex.RUnlock()
	argsForCall := fake.addDomainArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) AddDomainReturns(result1 error) {
	fake.addDomainMutex.Lock()
	defer fake.addDomainMutex.Unlock()
	fake.AddDomainStub = nil
	fake.addDomainReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddDomainReturnsOnCall(i int, result1 error) {
	fake.addDomainMutex.Lock()
	defer fake.addDomainMutex.Unlock()
	fake.AddDomainStub = nil
	if fake.addDomainReturnsOnCall == nil {
		fake.addDomainReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.addDomainReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddMessage(arg1 *letterbox.Mailbox, arg2 *letterbox.EncryptedMessage) error {
	fake.addMessageMutex.Lock()
	ret, specificReturn := fake.addMessageReturnsOnCall[len(fake.addMessageArgsForCall)]
	fake.addMessageArgsForCall = append(fake.addMessageArgsForCall, struct {
		arg1 *letterbox.Mailbox
		arg2 *letterbox.EncryptedMessage
	}{arg1, arg2})
	stub := fake.AddMessageStub
	fakeReturns := fake.addMessageReturns
	fake.recordInvocation("AddMessage", []interface{}{arg1, arg2})
	fake.addMessageMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) AddMessageCallCount() int {
	fake.addMessageMutex.RLock()
	defer fake.addMessageMutex.RUnlock()
	return len(fake.addMessageArgsForCall)
}

func (fake *FakeDatastore) AddMessageCalls(stub func(*letterbox.Mailbox, *letterbox.EncryptedMessage) error) {
	fake.addMessageMutex.Lock()
	defer fake.addMessageMutex.Unlock()
	fake.AddMessageStub = stub
}

func (fake *FakeDatastore) AddMessageArgsForCall(i int) (*letterbox.Mailbox, *letterbox.EncryptedMessage) {
	fake.addMessageMutex.RLock()
	defer fake.addMessageMutex.RUnlock()
	argsForCall := fake.addMessageArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeDatastore) AddMessageReturns(result1 error) {
	fake.addMessageMutex.Lock()
	defer fake.addMessageMutex.Unlock()
	fake.AddMessageStub = nil
	fake.addMessageReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddMessageReturnsOnCall(i int, result1 error) {
	fake.addMessageMutex.Lock()
	defer fake.addMessageMutex.Unlock()
	fake.AddMessageStub = nil
	if fake.addMessageReturnsOnCall == nil {
		fake.addMessageReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.addMessageReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddUser(arg1 *letterbox.User) error {
	fake.addUserMutex.Lock()
	ret, specificReturn := fake.addUserReturnsOnCall[len(fake.addUserArgsForCall)]
	fake.addUserArgsForCall = append(fake.addUserArgsForCall, struct {
		arg1 *letterbox.User
	}{arg1})
	stub := fake.AddUserStub
	fakeReturns := fake.addUserReturns
	fake.recordInvocation("AddUser", []interface{}{arg1})
	fake.addUserMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) AddUserCallCount() int {
	fake.addUserMutex.RLock()
	defer fake.addUserMutex.RUnlock()
	return len(fake.addUserArgsForCall)
}

func (fake *FakeDatastore) AddUserCalls(stub func(*letterbox.User) error) {
	fake.addUserMutex.Lock()
	defer fake.addUserMutex.Unlock()
	fake.AddUserStub = stub
}

func (fake *FakeDatastore) AddUserArgsForCall(i int) *letterbox.User {
	fake.addUserMutex.RLock()
	defer fake.addUserMutex.RUnlock()
	argsForCall := fake.addUserArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) AddUserReturns(result1 error) {
	fake.addUserMutex.Lock()
	defer fake.addUserMutex.Unlock()
	fake.AddUserStub = nil
	fake.addUserReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddUserReturnsOnCall(i int, result1 error) {
	fake.addUserMutex.Lock()
	defer fake.addUserMutex.Unlock()
	fake.AddUserStub = nil
	if fake.addUserReturnsOnCall == nil {
		fake.addUserReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.addUserReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddUserKey(arg1 *letterbox.User, arg2 *letterbox.UserKey) error {
	fake.addUserKeyMutex.Lock()
	ret, specificReturn := fake.addUserKeyReturnsOnCall[len(fake.addUserKeyArgsForCall)]
	fake.addUserKeyArgsForCall = append(fake.addUserKeyArgsForCall, struct {
		arg1 *letterbox.User
		arg2 *letterbox.UserKey
	}{arg1, arg2})
	stub := fake.AddUserKeyStub
	fakeReturns := fake.addUserKeyReturns
	fake.recordInvocation("AddUserKey", []interface{}{arg1, arg2})
	fake.addUserKeyMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) AddUserKeyCallCount() int {
	fake.addUserKeyMutex.RLock()
	defer fake.addUserKeyMutex.RUnlock()
	return len(fake.addUserKeyArgsForCall)
}

func (fake *FakeDatastore) AddUserKeyCalls(stub func(*letterbox.User, *letterbox.UserKey) error) {
	fake.addUserKeyMutex.Lock()
	defer fake.addUserKeyMutex.Unlock()
	fake.AddUserKeyStub = stub
}

func (fake *FakeDatastore) AddUserKeyArgsForCall(i int) (*letterbox.User, *letterbox.UserKey) {
	fake.addUserKeyMutex.RLock()
	defer fake.addUserKeyMutex.RUnlock()
	argsForCall := fake.addUserKeyArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeDatastore) AddUserKeyReturns(result1 error) {
	fake.addUserKeyMutex.Lock()
	defer fake.addUserKeyMutex.Unlock()
	fake.AddUserKeyStub = nil
	fake.addUserKeyReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) AddUserKeyReturnsOnCall(i int, result1 error) {
	fake.addUserKeyMutex.Lock()
	defer fake.addUserKeyMutex.Unlock()
	fake.AddUserKeyStub = nil
	if fake.addUserKeyReturnsOnCall == nil {
		fake.addUserKeyReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.addUserKeyReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) CreateStat(arg1 *letterbox.DomainStat) error {
	fake.createStatMutex.Lock()
	ret, specificReturn := fake.createStatReturnsOnCall[len(fake.createStatArgsForCall)]
	fake.createStatArgsForCall = append(fake.createStatArgsForCall, struct {
		arg1 *letterbox.DomainStat
	}{arg1})
	stub := fake.CreateStatStub
	fakeReturns := fake.createStatReturns
	fake.recordInvocation("CreateStat", []interface{}{arg1})
	fake.createStatMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) CreateStatCallCount() int {
	fake.createStatMutex.RLock()
	defer fake.createStatMutex.RUnlock()
	return len(fake.createStatArgsForCall)
}

func (fake *FakeDatastore) CreateStatCalls(stub func(*letterbox.DomainStat) error) {
	fake.createStatMutex.Lock()
	defer fake.createStatMutex.Unlock()
	fake.CreateStatStub = stub
}

func (fake *FakeDatastore) CreateStatArgsForCall(i int) *letterbox.DomainStat {
	fake.createStatMutex.RLock()
	defer fake.createStatMutex.RUnlock()
	argsForCall := fake.createStatArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) CreateStatReturns(result1 error) {
	fake.createStatMutex.Lock()
	defer fake.createStatMutex.Unlock()
	fake.CreateStatStub = nil
	fake.createStatReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) CreateStatReturnsOnCall(i int, result1 error) {
	fake.createStatMutex.Lock()
	defer fake.createStatMutex.Unlock()
	fake.CreateStatStub = nil
	if fake.createStatReturnsOnCall == nil {
		fake.createStatReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.createStatReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) DeleteDomain(arg1 *letterbox.Domain) error {
	fake.deleteDomainMutex.Lock()
	ret, specificReturn := fake.deleteDomainReturnsOnCall[len(fake.deleteDomainArgsForCall)]
	fake.deleteDomainArgsForCall = append(fake.deleteDomainArgsForCall, struct {
		arg1 *letterbox.Domain
	}{arg1})
	stub := fake.DeleteDomainStub
	fakeReturns := fake.deleteDomainReturns
	fake.recordInvocation("DeleteDomain", []interface{}{arg1})
	fake.deleteDomainMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) DeleteDomainCallCount() int {
	fake.deleteDomainMutex.RLock()
	defer fake.deleteDomainMutex.RUnlock()
	return len(fake.deleteDomainArgsForCall)
}

func (fake *FakeDatastore) DeleteDomainCalls(stub func(*letterbox.Domain) error) {
	fake.deleteDomainMutex.Lock()
	defer fake.deleteDomainMutex.Unlock()
	fake.DeleteDomainStub = stub
}

func (fake *FakeDatastore) DeleteDomainArgsForCall(i int) *letterbox.Domain {
	fake.deleteDomainMutex.RLock()
	defer fake.deleteDomainMutex.RUnlock()
	argsForCall := fake.deleteDomainArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) DeleteDomainReturns(result1 error) {
	fake.deleteDomainMutex.Lock()
	defer fake.deleteDomainMutex.Unlock()
	fake.DeleteDomainStub = nil
	fake.deleteDomainReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) DeleteDomainReturnsOnCall(i int, result1 error) {
	fake.deleteDomainMutex.Lock()
	defer fake.deleteDomainMutex.Unlock()
	fake.DeleteDomainStub = nil
	if fake.deleteDomainReturnsOnCall == nil {
		fake.deleteDomainReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteDomainReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) DeleteMailbox(arg1 *letterbox.Mailbox) error {
	fake.deleteMailboxMutex.Lock()
	ret, specificReturn := fake.deleteMailboxReturnsOnCall[len(fake.deleteMailboxArgsForCall)]
	fake.deleteMailboxArgsForCall = append(fake.deleteMailboxArgsForCall, struct {
		arg1 *letterbox.Mailbox
	}{arg1})
	stub := fake.DeleteMailboxStub
	fakeReturns := fake.deleteMailboxReturns
	fake.recordInvocation("DeleteMailbox", []interface{}{arg1})
	fake.deleteMailboxMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) DeleteMailboxCallCount() int {
	fake.deleteMailboxMutex.RLock()
	defer fake.deleteMailboxMutex.RUnlock()
	return len(fake.deleteMailboxArgsForCall)
}

func (fake *FakeDatastore) DeleteMailboxCalls(stub func(*letterbox.Mailbox) error) {
	fake.deleteMailboxMutex.Lock()
	defer fake.deleteMailboxMutex.Unlock()
	fake.DeleteMailboxStub = stub
}

func (fake *FakeDatastore) DeleteMailboxArgsForCall(i int) *letterbox.Mailbox {
	fake.deleteMailboxMutex.RLock()
	defer fake.deleteMailboxMutex.RUnlock()
	argsForCall := fake.deleteMailboxArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) DeleteMailboxReturns(result1 error) {
	fake.deleteMailboxMutex.Lock()
	defer fake.deleteMailboxMutex.Unlock()
	fake.DeleteMailboxStub = nil
	fake.deleteMailboxReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) DeleteMailboxReturnsOnCall(i int, result1 error) {
	fake.deleteMailboxMutex.Lock()
	defer fake.deleteMailboxMutex.Unlock()
	fake.DeleteMailboxStub = nil
	if fake.deleteMailboxReturnsOnCall == nil {
		fake.deleteMailboxReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteMailboxReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) DeleteMessage(arg1 *letterbox.EncryptedMessage) error {
	fake.deleteMessageMutex.Lock()
	ret, specificReturn := fake.deleteMessageReturnsOnCall[len(fake.deleteMessageArgsForCall)]
	fake.deleteMessageArgsForCall = append(fake.deleteMessageArgsForCall, struct {
		arg1 *letterbox.EncryptedMessage
	}{arg1})
	stub := fake.DeleteMessageStub
	fakeReturns := fake.deleteMessageReturns
	fake.recordInvocation("DeleteMessage", []interface{}{arg1})
	fake.deleteMessageMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) DeleteMessageCallCount() int {
	fake.deleteMessageMutex.RLock()
	defer fake.deleteMessageMutex.RUnlock()
	return len(fake.deleteMessageArgsForCall)
}

func (fake *FakeDatastore) DeleteMessageCalls(stub func(*letterbox.EncryptedMessage) error) {
	fake.deleteMessageMutex.Lock()
	defer fake.deleteMessageMutex.Unlock()
	fake.DeleteMessageStub = stub
}

func (fake *FakeDatastore) DeleteMessageArgsForCall(i int) *letterbox.EncryptedMessage {
	fake.deleteMessageMutex.RLock()
	defer fake.deleteMessageMutex.RUnlock()
	argsForCall := fake.deleteMessageArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) DeleteMessageReturns(result1 error) {
	fake.deleteMessageMutex.Lock()
	defer fake.deleteMessageMutex.Unlock()
	fake.DeleteMessageStub = nil
	fake.deleteMessageReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) DeleteMessageReturnsOnCall(i int, result1 error) {
	fake.deleteMessageMutex.Lock()
	defer fake.deleteMessageMutex.Unlock()
	fake.DeleteMessageStub = nil
	if fake.deleteMessageReturnsOnCall == nil {
		fake.deleteMessageReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.deleteMessageReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) GetAllDomains() ([]letterbox.Domain, error) {
	fake.getAllDomainsMutex.Lock()
	ret, specificReturn := fake.getAllDomainsReturnsOnCall[len(fake.getAllDomainsArgsForCall)]
	fake.getAllDomainsArgsForCall = append(fake.getAllDomainsArgsForCall, struct {
	}{})
	stub := fake.GetAllDomainsStub
	fakeReturns := fake.getAllDomainsReturns
	fake.recordInvocation("GetAllDomains", []interface{}{})
	fake.getAllDomainsMutex.Unlock()
	if stub != nil {
		return stub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetAllDomainsCallCount() int {
	fake.getAllDomainsMutex.RLock()
	defer fake.getAllDomainsMutex.RUnlock()
	return len(fake.getAllDomainsArgsForCall)
}

func (fake *FakeDatastore) GetAllDomainsCalls(stub func() ([]letterbox.Domain, error)) {
	fake.getAllDomainsMutex.Lock()
	defer fake.getAllDomainsMutex.Unlock()
	fake.GetAllDomainsStub = stub
}

func (fake *FakeDatastore) GetAllDomainsReturns(result1 []letterbox.Domain, result2 error) {
	fake.getAllDomainsMutex.Lock()
	defer fake.getAllDomainsMutex.Unlock()
	fake.GetAllDomainsStub = nil
	fake.getAllDomainsReturns = struct {
		result1 []letterbox.Domain
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetAllDomainsReturnsOnCall(i int, result1 []letterbox.Domain, result2 error) {
	fake.getAllDomainsMutex.Lock()
	defer fake.getAllDomainsMutex.Unlock()
	fake.GetAllDomainsStub = nil
	if fake.getAllDomainsReturnsOnCall == nil {
		fake.getAllDomainsReturnsOnCall = make(map[int]struct {
			result1 []letterbox.Domain
			result2 error
		})
	}
	fake.getAllDomainsReturnsOnCall[i] = struct {
		result1 []letterbox.Domain
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetAllMailboxes() ([]letterbox.Mailbox, error) {
	fake.getAllMailboxesMutex.Lock()
	ret, specificReturn := fake.getAllMailboxesReturnsOnCall[len(fake.getAllMailboxesArgsForCall)]
	fake.getAllMailboxesArgsForCall = append(fake.getAllMailboxesArgsForCall, struct {
	}{})
	stub := fake.GetAllMailboxesStub
	fakeReturns := fake.getAllMailboxesReturns
	fake.recordInvocation("GetAllMailboxes", []interface{}{})
	fake.getAllMailboxesMutex.Unlock()
	if stub != nil {
		return stub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetAllMailboxesCallCount() int {
	fake.getAllMailboxesMutex.RLock()
	defer fake.getAllMailboxesMutex.RUnlock()
	return len(fake.getAllMailboxesArgsForCall)
}

func (fake *FakeDatastore) GetAllMailboxesCalls(stub func() ([]letterbox.Mailbox, error)) {
	fake.getAllMailboxesMutex.Lock()
	defer fake.getAllMailboxesMutex.Unlock()
	fake.GetAllMailboxesStub = stub
}

func (fake *FakeDatastore) GetAllMailboxesReturns(result1 []letterbox.Mailbox, result2 error) {
	fake.getAllMailboxesMutex.Lock()
	defer fake.getAllMailboxesMutex.Unlock()
	fake.GetAllMailboxesStub = nil
	fake.getAllMailboxesReturns = struct {
		result1 []letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetAllMailboxesReturnsOnCall(i int, result1 []letterbox.Mailbox, result2 error) {
	fake.getAllMailboxesMutex.Lock()
	defer fake.getAllMailboxesMutex.Unlock()
	fake.GetAllMailboxesStub = nil
	if fake.getAllMailboxesReturnsOnCall == nil {
		fake.getAllMailboxesReturnsOnCall = make(map[int]struct {
			result1 []letterbox.Mailbox
			result2 error
		})
	}
	fake.getAllMailboxesReturnsOnCall[i] = struct {
		result1 []letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetAllUsers() ([]letterbox.User, error) {
	fake.getAllUsersMutex.Lock()
	ret, specificReturn := fake.getAllUsersReturnsOnCall[len(fake.getAllUsersArgsForCall)]
	fake.getAllUsersArgsForCall = append(fake.getAllUsersArgsForCall, struct {
	}{})
	stub := fake.GetAllUsersStub
	fakeReturns := fake.getAllUsersReturns
	fake.recordInvocation("GetAllUsers", []interface{}{})
	fake.getAllUsersMutex.Unlock()
	if stub != nil {
		return stub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetAllUsersCallCount() int {
	fake.getAllUsersMutex.RLock()
	defer fake.getAllUsersMutex.RUnlock()
	return len(fake.getAllUsersArgsForCall)
}

func (fake *FakeDatastore) GetAllUsersCalls(stub func() ([]letterbox.User, error)) {
	fake.getAllUsersMutex.Lock()
	defer fake.getAllUsersMutex.Unlock()
	fake.GetAllUsersStub = stub
}

func (fake *FakeDatastore) GetAllUsersReturns(result1 []letterbox.User, result2 error) {
	fake.getAllUsersMutex.Lock()
	defer fake.getAllUsersMutex.Unlock()
	fake.GetAllUsersStub = nil
	fake.getAllUsersReturns = struct {
		result1 []letterbox.User
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetAllUsersReturnsOnCall(i int, result1 []letterbox.User, result2 error) {
	fake.getAllUsersMutex.Lock()
	defer fake.getAllUsersMutex.Unlock()
	fake.GetAllUsersStub = nil
	if fake.getAllUsersReturnsOnCall == nil {
		fake.getAllUsersReturnsOnCall = make(map[int]struct {
			result1 []letterbox.User
			result2 error
		})
	}
	fake.getAllUsersReturnsOnCall[i] = struct {
		result1 []letterbox.User
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetDomain(arg1 string) (*letterbox.Domain, error) {
	fake.getDomainMutex.Lock()
	ret, specificReturn := fake.getDomainReturnsOnCall[len(fake.getDomainArgsForCall)]
	fake.getDomainArgsForCall = append(fake.getDomainArgsForCall, struct {
		arg1 string
	}{arg1})
	stub := fake.GetDomainStub
	fakeReturns := fake.getDomainReturns
	fake.recordInvocation("GetDomain", []interface{}{arg1})
	fake.getDomainMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetDomainCallCount() int {
	fake.getDomainMutex.RLock()
	defer fake.getDomainMutex.RUnlock()
	return len(fake.getDomainArgsForCall)
}

func (fake *FakeDatastore) GetDomainCalls(stub func(string) (*letterbox.Domain, error)) {
	fake.getDomainMutex.Lock()
	defer fake.getDomainMutex.Unlock()
	fake.GetDomainStub = stub
}

func (fake *FakeDatastore) GetDomainArgsForCall(i int) string {
	fake.getDomainMutex.RLock()
	defer fake.getDomainMutex.RUnlock()
	argsForCall := fake.getDomainArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetDomainReturns(result1 *letterbox.Domain, result2 error) {
	fake.getDomainMutex.Lock()
	defer fake.getDomainMutex.Unlock()
	fake.GetDomainStub = nil
	fake.getDomainReturns = struct {
		result1 *letterbox.Domain
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetDomainReturnsOnCall(i int, result1 *letterbox.Domain, result2 error) {
	fake.getDomainMutex.Lock()
	defer fake.getDomainMutex.Unlock()
	fake.GetDomainStub = nil
	if fake.getDomainReturnsOnCall == nil {
		fake.getDomainReturnsOnCall = make(map[int]struct {
			result1 *letterbox.Domain
			result2 error
		})
	}
	fake.getDomainReturnsOnCall[i] = struct {
		result1 *letterbox.Domain
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetExpiredMailboxes() ([]letterbox.Mailbox, error) {
	fake.getExpiredMailboxesMutex.Lock()
	ret, specificReturn := fake.getExpiredMailboxesReturnsOnCall[len(fake.getExpiredMailboxesArgsForCall)]
	fake.getExpiredMailboxesArgsForCall = append(fake.getExpiredMailboxesArgsForCall, struct {
	}{})
	stub := fake.GetExpiredMailboxesStub
	fakeReturns := fake.getExpiredMailboxesReturns
	fake.recordInvocation("GetExpiredMailboxes", []interface{}{})
	fake.getExpiredMailboxesMutex.Unlock()
	if stub != nil {
		return stub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetExpiredMailboxesCallCount() int {
	fake.getExpiredMailboxesMutex.RLock()
	defer fake.getExpiredMailboxesMutex.RUnlock()
	return len(fake.getExpiredMailboxesArgsForCall)
}

func (fake *FakeDatastore) GetExpiredMailboxesCalls(stub func() ([]letterbox.Mailbox, error)) {
	fake.getExpiredMailboxesMutex.Lock()
	defer fake.getExpiredMailboxesMutex.Unlock()
	fake.GetExpiredMailboxesStub = stub
}

func (fake *FakeDatastore) GetExpiredMailboxesReturns(result1 []letterbox.Mailbox, result2 error) {
	fake.getExpiredMailboxesMutex.Lock()
	defer fake.getExpiredMailboxesMutex.Unlock()
	fake.GetExpiredMailboxesStub = nil
	fake.getExpiredMailboxesReturns = struct {
		result1 []letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetExpiredMailboxesReturnsOnCall(i int, result1 []letterbox.Mailbox, result2 error) {
	fake.getExpiredMailboxesMutex.Lock()
	defer fake.getExpiredMailboxesMutex.Unlock()
	fake.GetExpiredMailboxesStub = nil
	if fake.getExpiredMailboxesReturnsOnCall == nil {
		fake.getExpiredMailboxesReturnsOnCall = make(map[int]struct {
			result1 []letterbox.Mailbox
			result2 error
		})
	}
	fake.getExpiredMailboxesReturnsOnCall[i] = struct {
		result1 []letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMailboxByDomain(arg1 *letterbox.Domain, arg2 string) (*letterbox.Mailbox, error) {
	fake.getMailboxByDomainMutex.Lock()
	ret, specificReturn := fake.getMailboxByDomainReturnsOnCall[len(fake.getMailboxByDomainArgsForCall)]
	fake.getMailboxByDomainArgsForCall = append(fake.getMailboxByDomainArgsForCall, struct {
		arg1 *letterbox.Domain
		arg2 string
	}{arg1, arg2})
	stub := fake.GetMailboxByDomainStub
	fakeReturns := fake.getMailboxByDomainReturns
	fake.recordInvocation("GetMailboxByDomain", []interface{}{arg1, arg2})
	fake.getMailboxByDomainMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetMailboxByDomainCallCount() int {
	fake.getMailboxByDomainMutex.RLock()
	defer fake.getMailboxByDomainMutex.RUnlock()
	return len(fake.getMailboxByDomainArgsForCall)
}

func (fake *FakeDatastore) GetMailboxByDomainCalls(stub func(*letterbox.Domain, string) (*letterbox.Mailbox, error)) {
	fake.getMailboxByDomainMutex.Lock()
	defer fake.getMailboxByDomainMutex.Unlock()
	fake.GetMailboxByDomainStub = stub
}

func (fake *FakeDatastore) GetMailboxByDomainArgsForCall(i int) (*letterbox.Domain, string) {
	fake.getMailboxByDomainMutex.RLock()
	defer fake.getMailboxByDomainMutex.RUnlock()
	argsForCall := fake.getMailboxByDomainArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeDatastore) GetMailboxByDomainReturns(result1 *letterbox.Mailbox, result2 error) {
	fake.getMailboxByDomainMutex.Lock()
	defer fake.getMailboxByDomainMutex.Unlock()
	fake.GetMailboxByDomainStub = nil
	fake.getMailboxByDomainReturns = struct {
		result1 *letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMailboxByDomainReturnsOnCall(i int, result1 *letterbox.Mailbox, result2 error) {
	fake.getMailboxByDomainMutex.Lock()
	defer fake.getMailboxByDomainMutex.Unlock()
	fake.GetMailboxByDomainStub = nil
	if fake.getMailboxByDomainReturnsOnCall == nil {
		fake.getMailboxByDomainReturnsOnCall = make(map[int]struct {
			result1 *letterbox.Mailbox
			result2 error
		})
	}
	fake.getMailboxByDomainReturnsOnCall[i] = struct {
		result1 *letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMailboxByExternalID(arg1 string) (*letterbox.Mailbox, error) {
	fake.getMailboxByExternalIDMutex.Lock()
	ret, specificReturn := fake.getMailboxByExternalIDReturnsOnCall[len(fake.getMailboxByExternalIDArgsForCall)]
	fake.getMailboxByExternalIDArgsForCall = append(fake.getMailboxByExternalIDArgsForCall, struct {
		arg1 string
	}{arg1})
	stub := fake.GetMailboxByExternalIDStub
	fakeReturns := fake.getMailboxByExternalIDReturns
	fake.recordInvocation("GetMailboxByExternalID", []interface{}{arg1})
	fake.getMailboxByExternalIDMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetMailboxByExternalIDCallCount() int {
	fake.getMailboxByExternalIDMutex.RLock()
	defer fake.getMailboxByExternalIDMutex.RUnlock()
	return len(fake.getMailboxByExternalIDArgsForCall)
}

func (fake *FakeDatastore) GetMailboxByExternalIDCalls(stub func(string) (*letterbox.Mailbox, error)) {
	fake.getMailboxByExternalIDMutex.Lock()
	defer fake.getMailboxByExternalIDMutex.Unlock()
	fake.GetMailboxByExternalIDStub = stub
}

func (fake *FakeDatastore) GetMailboxByExternalIDArgsForCall(i int) string {
	fake.getMailboxByExternalIDMutex.RLock()
	defer fake.getMailboxByExternalIDMutex.RUnlock()
	argsForCall := fake.getMailboxByExternalIDArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetMailboxByExternalIDReturns(result1 *letterbox.Mailbox, result2 error) {
	fake.getMailboxByExternalIDMutex.Lock()
	defer fake.getMailboxByExternalIDMutex.Unlock()
	fake.GetMailboxByExternalIDStub = nil
	fake.getMailboxByExternalIDReturns = struct {
		result1 *letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMailboxByExternalIDReturnsOnCall(i int, result1 *letterbox.Mailbox, result2 error) {
	fake.getMailboxByExternalIDMutex.Lock()
	defer fake.getMailboxByExternalIDMutex.Unlock()
	fake.GetMailboxByExternalIDStub = nil
	if fake.getMailboxByExternalIDReturnsOnCall == nil {
		fake.getMailboxByExternalIDReturnsOnCall = make(map[int]struct {
			result1 *letterbox.Mailbox
			result2 error
		})
	}
	fake.getMailboxByExternalIDReturnsOnCall[i] = struct {
		result1 *letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMailboxesByDomain(arg1 *letterbox.Domain) ([]letterbox.Mailbox, error) {
	fake.getMailboxesByDomainMutex.Lock()
	ret, specificReturn := fake.getMailboxesByDomainReturnsOnCall[len(fake.getMailboxesByDomainArgsForCall)]
	fake.getMailboxesByDomainArgsForCall = append(fake.getMailboxesByDomainArgsForCall, struct {
		arg1 *letterbox.Domain
	}{arg1})
	stub := fake.GetMailboxesByDomainStub
	fakeReturns := fake.getMailboxesByDomainReturns
	fake.recordInvocation("GetMailboxesByDomain", []interface{}{arg1})
	fake.getMailboxesByDomainMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetMailboxesByDomainCallCount() int {
	fake.getMailboxesByDomainMutex.RLock()
	defer fake.getMailboxesByDomainMutex.RUnlock()
	return len(fake.getMailboxesByDomainArgsForCall)
}

func (fake *FakeDatastore) GetMailboxesByDomainCalls(stub func(*letterbox.Domain) ([]letterbox.Mailbox, error)) {
	fake.getMailboxesByDomainMutex.Lock()
	defer fake.getMailboxesByDomainMutex.Unlock()
	fake.GetMailboxesByDomainStub = stub
}

func (fake *FakeDatastore) GetMailboxesByDomainArgsForCall(i int) *letterbox.Domain {
	fake.getMailboxesByDomainMutex.RLock()
	defer fake.getMailboxesByDomainMutex.RUnlock()
	argsForCall := fake.getMailboxesByDomainArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetMailboxesByDomainReturns(result1 []letterbox.Mailbox, result2 error) {
	fake.getMailboxesByDomainMutex.Lock()
	defer fake.getMailboxesByDomainMutex.Unlock()
	fake.GetMailboxesByDomainStub = nil
	fake.getMailboxesByDomainReturns = struct {
		result1 []letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMailboxesByDomainReturnsOnCall(i int, result1 []letterbox.Mailbox, result2 error) {
	fake.getMailboxesByDomainMutex.Lock()
	defer fake.getMailboxesByDomainMutex.Unlock()
	fake.GetMailboxesByDomainStub = nil
	if fake.getMailboxesByDomainReturnsOnCall == nil {
		fake.getMailboxesByDomainReturnsOnCall = make(map[int]struct {
			result1 []letterbox.Mailbox
			result2 error
		})
	}
	fake.getMailboxesByDomainReturnsOnCall[i] = struct {
		result1 []letterbox.Mailbox
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMessages(arg1 *letterbox.Mailbox) ([]letterbox.EncryptedMessage, error) {
	fake.getMessagesMutex.Lock()
	ret, specificReturn := fake.getMessagesReturnsOnCall[len(fake.getMessagesArgsForCall)]
	fake.getMessagesArgsForCall = append(fake.getMessagesArgsForCall, struct {
		arg1 *letterbox.Mailbox
	}{arg1})
	stub := fake.GetMessagesStub
	fakeReturns := fake.getMessagesReturns
	fake.recordInvocation("GetMessages", []interface{}{arg1})
	fake.getMessagesMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetMessagesCallCount() int {
	fake.getMessagesMutex.RLock()
	defer fake.getMessagesMutex.RUnlock()
	return len(fake.getMessagesArgsForCall)
}

func (fake *FakeDatastore) GetMessagesCalls(stub func(*letterbox.Mailbox) ([]letterbox.EncryptedMessage, error)) {
	fake.getMessagesMutex.Lock()
	defer fake.getMessagesMutex.Unlock()
	fake.GetMessagesStub = stub
}

func (fake *FakeDatastore) GetMessagesArgsForCall(i int) *letterbox.Mailbox {
	fake.getMessagesMutex.RLock()
	defer fake.getMessagesMutex.RUnlock()
	argsForCall := fake.getMessagesArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetMessagesReturns(result1 []letterbox.EncryptedMessage, result2 error) {
	fake.getMessagesMutex.Lock()
	defer fake.getMessagesMutex.Unlock()
	fake.GetMessagesStub = nil
	fake.getMessagesReturns = struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMessagesReturnsOnCall(i int, result1 []letterbox.EncryptedMessage, result2 error) {
	fake.getMessagesMutex.Lock()
	defer fake.getMessagesMutex.Unlock()
	fake.GetMessagesStub = nil
	if fake.getMessagesReturnsOnCall == nil {
		fake.getMessagesReturnsOnCall = make(map[int]struct {
			result1 []letterbox.EncryptedMessage
			result2 error
		})
	}
	fake.getMessagesReturnsOnCall[i] = struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMessagesForUser(arg1 *letterbox.User) ([]letterbox.EncryptedMessage, error) {
	fake.getMessagesForUserMutex.Lock()
	ret, specificReturn := fake.getMessagesForUserReturnsOnCall[len(fake.getMessagesForUserArgsForCall)]
	fake.getMessagesForUserArgsForCall = append(fake.getMessagesForUserArgsForCall, struct {
		arg1 *letterbox.User
	}{arg1})
	stub := fake.GetMessagesForUserStub
	fakeReturns := fake.getMessagesForUserReturns
	fake.recordInvocation("GetMessagesForUser", []interface{}{arg1})
	fake.getMessagesForUserMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetMessagesForUserCallCount() int {
	fake.getMessagesForUserMutex.RLock()
	defer fake.getMessagesForUserMutex.RUnlock()
	return len(fake.getMessagesForUserArgsForCall)
}

func (fake *FakeDatastore) GetMessagesForUserCalls(stub func(*letterbox.User) ([]letterbox.EncryptedMessage, error)) {
	fake.getMessagesForUserMutex.Lock()
	defer fake.getMessagesForUserMutex.Unlock()
	fake.GetMessagesForUserStub = stub
}

func (fake *FakeDatastore) GetMessagesForUserArgsForCall(i int) *letterbox.User {
	fake.getMessagesForUserMutex.RLock()
	defer fake.getMessagesForUserMutex.RUnlock()
	argsForCall := fake.getMessagesForUserArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetMessagesForUserReturns(result1 []letterbox.EncryptedMessage, result2 error) {
	fake.getMessagesForUserMutex.Lock()
	defer fake.getMessagesForUserMutex.Unlock()
	fake.GetMessagesForUserStub = nil
	fake.getMessagesForUserReturns = struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetMessagesForUserReturnsOnCall(i int, result1 []letterbox.EncryptedMessage, result2 error) {
	fake.getMessagesForUserMutex.Lock()
	defer fake.getMessagesForUserMutex.Unlock()
	fake.GetMessagesForUserStub = nil
	if fake.getMessagesForUserReturnsOnCall == nil {
		fake.getMessagesForUserReturnsOnCall = make(map[int]struct {
			result1 []letterbox.EncryptedMessage
			result2 error
		})
	}
	fake.getMessagesForUserReturnsOnCall[i] = struct {
		result1 []letterbox.EncryptedMessage
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetStat(arg1 uint, arg2 string) (*letterbox.DomainStat, error) {
	fake.getStatMutex.Lock()
	ret, specificReturn := fake.getStatReturnsOnCall[len(fake.getStatArgsForCall)]
	fake.getStatArgsForCall = append(fake.getStatArgsForCall, struct {
		arg1 uint
		arg2 string
	}{arg1, arg2})
	stub := fake.GetStatStub
	fakeReturns := fake.getStatReturns
	fake.recordInvocation("GetStat", []interface{}{arg1, arg2})
	fake.getStatMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetStatCallCount() int {
	fake.getStatMutex.RLock()
	defer fake.getStatMutex.RUnlock()
	return len(fake.getStatArgsForCall)
}

func (fake *FakeDatastore) GetStatCalls(stub func(uint, string) (*letterbox.DomainStat, error)) {
	fake.getStatMutex.Lock()
	defer fake.getStatMutex.Unlock()
	fake.GetStatStub = stub
}

func (fake *FakeDatastore) GetStatArgsForCall(i int) (uint, string) {
	fake.getStatMutex.RLock()
	defer fake.getStatMutex.RUnlock()
	argsForCall := fake.getStatArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeDatastore) GetStatReturns(result1 *letterbox.DomainStat, result2 error) {
	fake.getStatMutex.Lock()
	defer fake.getStatMutex.Unlock()
	fake.GetStatStub = nil
	fake.getStatReturns = struct {
		result1 *letterbox.DomainStat
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetStatReturnsOnCall(i int, result1 *letterbox.DomainStat, result2 error) {
	fake.getStatMutex.Lock()
	defer fake.getStatMutex.Unlock()
	fake.GetStatStub = nil
	if fake.getStatReturnsOnCall == nil {
		fake.getStatReturnsOnCall = make(map[int]struct {
			result1 *letterbox.DomainStat
			result2 error
		})
	}
	fake.getStatReturnsOnCall[i] = struct {
		result1 *letterbox.DomainStat
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetUser(arg1 string) (*letterbox.User, error) {
	fake.getUserMutex.Lock()
	ret, specificReturn := fake.getUserReturnsOnCall[len(fake.getUserArgsForCall)]
	fake.getUserArgsForCall = append(fake.getUserArgsForCall, struct {
		arg1 string
	}{arg1})
	stub := fake.GetUserStub
	fakeReturns := fake.getUserReturns
	fake.recordInvocation("GetUser", []interface{}{arg1})
	fake.getUserMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetUserCallCount() int {
	fake.getUserMutex.RLock()
	defer fake.getUserMutex.RUnlock()
	return len(fake.getUserArgsForCall)
}

func (fake *FakeDatastore) GetUserCalls(stub func(string) (*letterbox.User, error)) {
	fake.getUserMutex.Lock()
	defer fake.getUserMutex.Unlock()
	fake.GetUserStub = stub
}

func (fake *FakeDatastore) GetUserArgsForCall(i int) string {
	fake.getUserMutex.RLock()
	defer fake.getUserMutex.RUnlock()
	argsForCall := fake.getUserArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetUserReturns(result1 *letterbox.User, result2 error) {
	fake.getUserMutex.Lock()
	defer fake.getUserMutex.Unlock()
	fake.GetUserStub = nil
	fake.getUserReturns = struct {
		result1 *letterbox.User
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetUserReturnsOnCall(i int, result1 *letterbox.User, result2 error) {
	fake.getUserMutex.Lock()
	defer fake.getUserMutex.Unlock()
	fake.GetUserStub = nil
	if fake.getUserReturnsOnCall == nil {
		fake.getUserReturnsOnCall = make(map[int]struct {
			result1 *letterbox.User
			result2 error
		})
	}
	fake.getUserReturnsOnCall[i] = struct {
		result1 *letterbox.User
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetUserByID(arg1 uint) (*letterbox.User, error) {
	fake.getUserByIDMutex.Lock()
	ret, specificReturn := fake.getUserByIDReturnsOnCall[len(fake.getUserByIDArgsForCall)]
	fake.getUserByIDArgsForCall = append(fake.getUserByIDArgsForCall, struct {
		arg1 uint
	}{arg1})
	stub := fake.GetUserByIDStub
	fakeReturns := fake.getUserByIDReturns
	fake.recordInvocation("GetUserByID", []interface{}{arg1})
	fake.getUserByIDMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetUserByIDCallCount() int {
	fake.getUserByIDMutex.RLock()
	defer fake.getUserByIDMutex.RUnlock()
	return len(fake.getUserByIDArgsForCall)
}

func (fake *FakeDatastore) GetUserByIDCalls(stub func(uint) (*letterbox.User, error)) {
	fake.getUserByIDMutex.Lock()
	defer fake.getUserByIDMutex.Unlock()
	fake.GetUserByIDStub = stub
}

func (fake *FakeDatastore) GetUserByIDArgsForCall(i int) uint {
	fake.getUserByIDMutex.RLock()
	defer fake.getUserByIDMutex.RUnlock()
	argsForCall := fake.getUserByIDArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetUserByIDReturns(result1 *letterbox.User, result2 error) {
	fake.getUserByIDMutex.Lock()
	defer fake.getUserByIDMutex.Unlock()
	fake.GetUserByIDStub = nil
	fake.getUserByIDReturns = struct {
		result1 *letterbox.User
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetUserByIDReturnsOnCall(i int, result1 *letterbox.User, result2 error) {
	fake.getUserByIDMutex.Lock()
	defer fake.getUserByIDMutex.Unlock()
	fake.GetUserByIDStub = nil
	if fake.getUserByIDReturnsOnCall == nil {
		fake.getUserByIDReturnsOnCall = make(map[int]struct {
			result1 *letterbox.User
			result2 error
		})
	}
	fake.getUserByIDReturnsOnCall[i] = struct {
		result1 *letterbox.User
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetUserKey(arg1 *letterbox.User) (*letterbox.UserKey, error) {
	fake.getUserKeyMutex.Lock()
	ret, specificReturn := fake.getUserKeyReturnsOnCall[len(fake.getUserKeyArgsForCall)]
	fake.getUserKeyArgsForCall = append(fake.getUserKeyArgsForCall, struct {
		arg1 *letterbox.User
	}{arg1})
	stub := fake.GetUserKeyStub
	fakeReturns := fake.getUserKeyReturns
	fake.recordInvocation("GetUserKey", []interface{}{arg1})
	fake.getUserKeyMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDatastore) GetUserKeyCallCount() int {
	fake.getUserKeyMutex.RLock()
	defer fake.getUserKeyMutex.RUnlock()
	return len(fake.getUserKeyArgsForCall)
}

func (fake *FakeDatastore) GetUserKeyCalls(stub func(*letterbox.User) (*letterbox.UserKey, error)) {
	fake.getUserKeyMutex.Lock()
	defer fake.getUserKeyMutex.Unlock()
	fake.GetUserKeyStub = stub
}

func (fake *FakeDatastore) GetUserKeyArgsForCall(i int) *letterbox.User {
	fake.getUserKeyMutex.RLock()
	defer fake.getUserKeyMutex.RUnlock()
	argsForCall := fake.getUserKeyArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) GetUserKeyReturns(result1 *letterbox.UserKey, result2 error) {
	fake.getUserKeyMutex.Lock()
	defer fake.getUserKeyMutex.Unlock()
	fake.GetUserKeyStub = nil
	fake.getUserKeyReturns = struct {
		result1 *letterbox.UserKey
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) GetUserKeyReturnsOnCall(i int, result1 *letterbox.UserKey, result2 error) {
	fake.getUserKeyMutex.Lock()
	defer fake.getUserKeyMutex.Unlock()
	fake.GetUserKeyStub = nil
	if fake.getUserKeyReturnsOnCall == nil {
		fake.getUserKeyReturnsOnCall = make(map[int]struct {
			result1 *letterbox.UserKey
			result2 error
		})
	}
	fake.getUserKeyReturnsOnCall[i] = struct {
		result1 *letterbox.UserKey
		result2 error
	}{result1, result2}
}

func (fake *FakeDatastore) UpdateMailbox(arg1 *letterbox.Mailbox) error {
	fake.updateMailboxMutex.Lock()
	ret, specificReturn := fake.updateMailboxReturnsOnCall[len(fake.updateMailboxArgsForCall)]
	fake.updateMailboxArgsForCall = append(fake.updateMailboxArgsForCall, struct {
		arg1 *letterbox.Mailbox
	}{arg1})
	stub := fake.UpdateMailboxStub
	fakeReturns := fake.updateMailboxReturns
	fake.recordInvocation("UpdateMailbox", []interface{}{arg1})
	fake.updateMailboxMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) UpdateMailboxCallCount() int {
	fake.updateMailboxMutex.RLock()
	defer fake.updateMailboxMutex.RUnlock()
	return len(fake.updateMailboxArgsForCall)
}

func (fake *FakeDatastore) UpdateMailboxCalls(stub func(*letterbox.Mailbox) error) {
	fake.updateMailboxMutex.Lock()
	defer fake.updateMailboxMutex.Unlock()
	fake.UpdateMailboxStub = stub
}

func (fake *FakeDatastore) UpdateMailboxArgsForCall(i int) *letterbox.Mailbox {
	fake.updateMailboxMutex.RLock()
	defer fake.updateMailboxMutex.RUnlock()
	argsForCall := fake.updateMailboxArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) UpdateMailboxReturns(result1 error) {
	fake.updateMailboxMutex.Lock()
	defer fake.updateMailboxMutex.Unlock()
	fake.UpdateMailboxStub = nil
	fake.updateMailboxReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateMailboxReturnsOnCall(i int, result1 error) {
	fake.updateMailboxMutex.Lock()
	defer fake.updateMailboxMutex.Unlock()
	fake.UpdateMailboxStub = nil
	if fake.updateMailboxReturnsOnCall == nil {
		fake.updateMailboxReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateMailboxReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateMessage(arg1 *letterbox.EncryptedMessage) error {
	fake.updateMessageMutex.Lock()
	ret, specificReturn := fake.updateMessageReturnsOnCall[len(fake.updateMessageArgsForCall)]
	fake.updateMessageArgsForCall = append(fake.updateMessageArgsForCall, struct {
		arg1 *letterbox.EncryptedMessage
	}{arg1})
	stub := fake.UpdateMessageStub
	fakeReturns := fake.updateMessageReturns
	fake.recordInvocation("UpdateMessage", []interface{}{arg1})
	fake.updateMessageMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) UpdateMessageCallCount() int {
	fake.updateMessageMutex.RLock()
	defer fake.updateMessageMutex.RUnlock()
	return len(fake.updateMessageArgsForCall)
}

func (fake *FakeDatastore) UpdateMessageCalls(stub func(*letterbox.EncryptedMessage) error) {
	fake.updateMessageMutex.Lock()
	defer fake.updateMessageMutex.Unlock()
	fake.UpdateMessageStub = stub
}

func (fake *FakeDatastore) UpdateMessageArgsForCall(i int) *letterbox.EncryptedMessage {
	fake.updateMessageMutex.RLock()
	defer fake.updateMessageMutex.RUnlock()
	argsForCall := fake.updateMessageArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) UpdateMessageReturns(result1 error) {
	fake.updateMessageMutex.Lock()
	defer fake.updateMessageMutex.Unlock()
	fake.UpdateMessageStub = nil
	fake.updateMessageReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateMessageReturnsOnCall(i int, result1 error) {
	fake.updateMessageMutex.Lock()
	defer fake.updateMessageMutex.Unlock()
	fake.UpdateMessageStub = nil
	if fake.updateMessageReturnsOnCall == nil {
		fake.updateMessageReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateMessageReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateStat(arg1 *letterbox.DomainStat) error {
	fake.updateStatMutex.Lock()
	ret, specificReturn := fake.updateStatReturnsOnCall[len(fake.updateStatArgsForCall)]
	fake.updateStatArgsForCall = append(fake.updateStatArgsForCall, struct {
		arg1 *letterbox.DomainStat
	}{arg1})
	stub := fake.UpdateStatStub
	fakeReturns := fake.updateStatReturns
	fake.recordInvocation("UpdateStat", []interface{}{arg1})
	fake.updateStatMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) UpdateStatCallCount() int {
	fake.updateStatMutex.RLock()
	defer fake.updateStatMutex.RUnlock()
	return len(fake.updateStatArgsForCall)
}

func (fake *FakeDatastore) UpdateStatCalls(stub func(*letterbox.DomainStat) error) {
	fake.updateStatMutex.Lock()
	defer fake.updateStatMutex.Unlock()
	fake.UpdateStatStub = stub
}

func (fake *FakeDatastore) UpdateStatArgsForCall(i int) *letterbox.DomainStat {
	fake.updateStatMutex.RLock()
	defer fake.updateStatMutex.RUnlock()
	argsForCall := fake.updateStatArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) UpdateStatReturns(result1 error) {
	fake.updateStatMutex.Lock()
	defer fake.updateStatMutex.Unlock()
	fake.UpdateStatStub = nil
	fake.updateStatReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateStatReturnsOnCall(i int, result1 error) {
	fake.updateStatMutex.Lock()
	defer fake.updateStatMutex.Unlock()
	fake.UpdateStatStub = nil
	if fake.updateStatReturnsOnCall == nil {
		fake.updateStatReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateStatReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateUser(arg1 *letterbox.User) error {
	fake.updateUserMutex.Lock()
	ret, specificReturn := fake.updateUserReturnsOnCall[len(fake.updateUserArgsForCall)]
	fake.updateUserArgsForCall = append(fake.updateUserArgsForCall, struct {
		arg1 *letterbox.User
	}{arg1})
	stub := fake.UpdateUserStub
	fakeReturns := fake.updateUserReturns
	fake.recordInvocation("UpdateUser", []interface{}{arg1})
	fake.updateUserMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) UpdateUserCallCount() int {
	fake.updateUserMutex.RLock()
	defer fake.updateUserMutex.RUnlock()
	return len(fake.updateUserArgsForCall)
}

func (fake *FakeDatastore) UpdateUserCalls(stub func(*letterbox.User) error) {
	fake.updateUserMutex.Lock()
	defer fake.updateUserMutex.Unlock()
	fake.UpdateUserStub = stub
}

func (fake *FakeDatastore) UpdateUserArgsForCall(i int) *letterbox.User {
	fake.updateUserMutex.RLock()
	defer fake.updateUserMutex.RUnlock()
	argsForCall := fake.updateUserArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) UpdateUserReturns(result1 error) {
	fake.updateUserMutex.Lock()
	defer fake.updateUserMutex.Unlock()
	fake.UpdateUserStub = nil
	fake.updateUserReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateUserReturnsOnCall(i int, result1 error) {
	fake.updateUserMutex.Lock()
	defer fake.updateUserMutex.Unlock()
	fake.UpdateUserStub = nil
	if fake.updateUserReturnsOnCall == nil {
		fake.updateUserReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateUserReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateUserKey(arg1 *letterbox.UserKey) error {
	fake.updateUserKeyMutex.Lock()
	ret, specificReturn := fake.updateUserKeyReturnsOnCall[len(fake.updateUserKeyArgsForCall)]
	fake.updateUserKeyArgsForCall = append(fake.updateUserKeyArgsForCall, struct {
		arg1 *letterbox.UserKey
	}{arg1})
	stub := fake.UpdateUserKeyStub
	fakeReturns := fake.updateUserKeyReturns
	fake.recordInvocation("UpdateUserKey", []interface{}{arg1})
	fake.updateUserKeyMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeDatastore) UpdateUserKeyCallCount() int {
	fake.updateUserKeyMutex.RLock()
	defer fake.updateUserKeyMutex.RUnlock()
	return len(fake.updateUserKeyArgsForCall)
}

func (fake *FakeDatastore) UpdateUserKeyCalls(stub func(*letterbox.UserKey) error) {
	fake.updateUserKeyMutex.Lock()
	defer fake.updateUserKeyMutex.Unlock()
	fake.UpdateUserKeyStub = stub
}

func (fake *FakeDatastore) UpdateUserKeyArgsForCall(i int) *letterbox.UserKey {
	fake.updateUserKeyMutex.RLock()
	defer fake.updateUserKeyMutex.RUnlock()
	argsForCall := fake.updateUserKeyArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDatastore) UpdateUserKeyReturns(result1 error) {
	fake.updateUserKeyMutex.Lock()
	defer fake.updateUserKeyMutex.Unlock()
	fake.UpdateUserKeyStub = nil
	fake.updateUserKeyReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) UpdateUserKeyReturnsOnCall(i int, result1 error) {
	fake.updateUserKeyMutex.Lock()
	defer fake.updateUserKeyMutex.Unlock()
	fake.UpdateUserKeyStub = nil
	if fake.updateUserKeyReturnsOnCall == nil {
		fake.updateUserKeyReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.updateUserKeyReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeDatastore) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.addDomainMutex.RLock()
	defer fake.addDomainMutex.RUnlock()
	fake.addMessageMutex.RLock()
	defer fake.addMessageMutex.RUnlock()
	fake.addUserMutex.RLock()
	defer fake.addUserMutex.RUnlock()
	fake.addUserKeyMutex.RLock()
	defer fake.addUserKeyMutex.RUnlock()
	fake.createStatMutex.RLock()
	defer fake.createStatMutex.RUnlock()
	fake.deleteDomainMutex.RLock()
	defer fake.deleteDomainMutex.RUnlock()
	fake.deleteMailboxMutex.RLock()
	defer fake.deleteMailboxMutex.RUnlock()
	fake.deleteMessageMutex.RLock()
	defer fake.deleteMessageMutex.RUnlock()
	fake.getAllDomainsMutex.RLock()
	defer fake.getAllDomainsMutex.RUnlock()
	fake.getAllMailboxesMutex.RLock()
	defer fake.getAllMailboxesMutex.RUnlock()
	fake.getAllUsersMutex.RLock()
	defer fake.getAllUsersMutex.RUnlock()
	fake.getDomainMutex.RLock()
	defer fake.getDomainMutex.RUnlock()
	fake.getExpiredMailboxesMutex.RLock()
	defer fake.getExpiredMailboxesMutex.RUnlock()
	fake.getMailboxByDomainMutex.RLock()
	defer fake.getMailboxByDomainMutex.RUnlock()
	fake.getMailboxByExternalIDMutex.RLock()
	defer fake.getMailboxByExternalIDMutex.RUnlock()
	fake.getMailboxesByDomainMutex.RLock()
	defer fake.getMailboxesByDomainMutex.RUnlock()
	fake.getMessagesMutex.RLock()
	defer fake.getMessagesMutex.RUnlock()
	fake.getMessagesForUserMutex.RLock()
	defer fake.getMessagesForUserMutex.RUnlock()
	fake.getStatMutex.RLock()
	defer fake.getStatMutex.RUnlock()
	fake.getUserMutex.RLock()
	defer fake.getUserMutex.RUnlock()
	fake.getUserByIDMutex.RLock()
	defer fake.getUserByIDMutex.RUnlock()
	fake.getUserKeyMutex.RLock()
	defer fake.getUserKeyMutex.RUnlock()
	fake.updateMailboxMutex.RLock()
	defer fake.updateMailboxMutex.RUnlock()
	fake.updateMessageMutex.RLock()
	defer fake.updateMessageMutex.RUnlock()
	fake.updateStatMutex.RLock()
	defer fake.updateStatMutex.RUnlock()
	fake.updateUserMutex.RLock()
	defer fake.updateUserMutex.RUnlock()
	fake.updateUserKeyMutex.RLock()
	defer fake.updateUserKeyMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeDatastore) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ letterbox.Datastore = new(FakeDatastore)
